// Generated by CoffeeScript 1.6.3
var Field, IntegerField, JSONField, NumberField, StringField, TimestampField, createField, fieldTypes, toType, _ref, _ref1, _ref2, _ref3, _ref4, _ref5,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

toType = require('./utils').toType;

Field = (function() {
  function Field(attrs) {
    var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
    this.name = attrs.name;
    this.column = (_ref = attrs.column) != null ? _ref : this.name;
    this.validator = (_ref1 = attrs.validator) != null ? _ref1 : null;
    this.required = (_ref2 = attrs.required) != null ? _ref2 : false;
    this.primkey = (_ref3 = attrs.primkey) != null ? _ref3 : false;
    this.auto = (_ref4 = attrs.auto) != null ? _ref4 : false;
    this.uniq = (_ref5 = attrs.uniq) != null ? _ref5 : false;
  }

  Field.prototype.say = function() {
    return console.log('喵');
  };

  Field.prototype.toDB = function(val) {
    return val;
  };

  Field.prototype.fromDB = function(val) {
    return val;
  };

  return Field;

})();

fieldTypes = {};

fieldTypes['integer'] = IntegerField = (function(_super) {
  __extends(IntegerField, _super);

  function IntegerField() {
    _ref = IntegerField.__super__.constructor.apply(this, arguments);
    return _ref;
  }

  IntegerField.prototype.toDB = function(val) {
    return val;
  };

  IntegerField.prototype.fromDB = function(val) {
    return val;
  };

  IntegerField.prototype.defaultValue = function() {
    return 0;
  };

  return IntegerField;

})(Field);

fieldTypes['number'] = NumberField = (function(_super) {
  __extends(NumberField, _super);

  function NumberField() {
    _ref1 = NumberField.__super__.constructor.apply(this, arguments);
    return _ref1;
  }

  NumberField.prototype.toDB = function(val) {
    return val;
  };

  NumberField.prototype.fromDB = function(val) {
    return val;
  };

  NumberField.prototype.defaultValue = function() {
    return 0;
  };

  return NumberField;

})(Field);

fieldTypes['string'] = StringField = (function(_super) {
  __extends(StringField, _super);

  function StringField() {
    _ref2 = StringField.__super__.constructor.apply(this, arguments);
    return _ref2;
  }

  StringField.prototype.toDB = function(val) {
    return val;
  };

  StringField.prototype.fromDB = function(val) {
    return val;
  };

  StringField.prototype.defaultValue = function() {
    return '';
  };

  return StringField;

})(Field);

fieldTypes['boolean'] = StringField = (function(_super) {
  __extends(StringField, _super);

  function StringField() {
    _ref3 = StringField.__super__.constructor.apply(this, arguments);
    return _ref3;
  }

  StringField.prototype.toDB = function(val) {
    if (val === 'true' || val === true) {
      return 'true';
    } else {
      return 'false';
    }
  };

  StringField.prototype.fromDB = function(val) {
    if (val === 'true' || val === true) {
      return true;
    } else {
      return false;
    }
  };

  StringField.prototype.defaultValue = function() {
    return null;
  };

  return StringField;

})(Field);

fieldTypes['timestamp'] = TimestampField = (function(_super) {
  __extends(TimestampField, _super);

  function TimestampField() {
    _ref4 = TimestampField.__super__.constructor.apply(this, arguments);
    return _ref4;
  }

  TimestampField.prototype.toDB = function(val) {
    var e;
    if (val == null) {
      return val;
    }
    try {
      return (new Date(val)).toISOString();
    } catch (_error) {
      e = _error;
      return null;
    }
  };

  TimestampField.prototype.fromDB = function(val) {
    var e;
    if (val == null) {
      return val;
    }
    try {
      return new Date(val);
    } catch (_error) {
      e = _error;
      return null;
    }
  };

  return TimestampField;

})(Field);

fieldTypes['json'] = JSONField = (function(_super) {
  __extends(JSONField, _super);

  function JSONField() {
    _ref5 = JSONField.__super__.constructor.apply(this, arguments);
    return _ref5;
  }

  JSONField.prototype.toDB = function(val) {
    if (val == null) {
      return val;
    }
    return JSON.stringify(val);
  };

  JSONField.prototype.fromDB = function(val) {
    var e;
    if (val == null) {
      return val;
    }
    try {
      return JSON.parse(val);
    } catch (_error) {
      e = _error;
      return val;
    }
  };

  JSONField.prototype.defaultValue = function() {
    return {};
  };

  return JSONField;

})(Field);

createField = function(define) {
  var FieldType;
  FieldType = fieldTypes[define.type] || Field;
  return new FieldType(define);
};

exports.createField = createField;
